include <imhdr.h>
include "quad.h"

procedure t_quadjoin ()

char	input[SZ_FNAME]			#TI Input image root name.
char	output[SZ_FNAME]		#TI Output image name.
char	instrument[SZ_FNAME]		#TI Output image root name.

pointer	in1, in2, in3, in4, out, inbuf1, inbuf2, outbuf
int	junk, nx1, nx2, nxo, ny1, ny3, nyo
long	invec1[IM_MAXDIM], invec2[IM_MAXDIM], ovec[IM_MAXDIM]

pointer	immap(), quadmap()
int	imgnls(), imgnll(), imgnlr, imgnld, imgnlx
int	impnls(), impnll(), impnlr, impnld, impnlx

begin
	# Open instrument file
	call clgstr    ("ccdred.instrument",  instrument,  SZ_FNAME)
	call hdmopen   (instrument)

	# Open input images
	call clgstr ("input", input,  SZ_FNAME)
	in1 = quadmap (input, 1, READ_ONLY, 0)
	in2 = quadmap (input, 2, READ_ONLY, 0)
	in3 = quadmap (input, 3, READ_ONLY, 0)
	in4 = quadmap (input, 4, READ_ONLY, 0)

	# Open output image
	call clgstr ("output", output, SZ_FNAME)
	out = immap (output, NEW_COPY, in1)

	nx1 = IM_LEN (in1, 1)
	ny1 = IM_LEN (in1, 2)
	nx2 = IM_LEN (in2, 1)
	ny3 = IM_LEN (in3, 2)
	nxo = nx1 + nx2
	nyo = ny1 + ny3
	IM_LEN (out, 1) = nxo
	IM_LEN (out, 2) = nyo

	# Setup start vector for sequential writes
	call amovkl (long(1), ovec, IM_MAXDIM)

        switch (IM_PIXTYPE(in1)) {

        case TY_SHORT:
	    # Copy first two quadrants
	    call amovkl (long(1), invec1, IM_MAXDIM)
	    call amovkl (long(1), invec2, IM_MAXDIM)
            while (imgnls (in1, inbuf1, invec1) != EOF) {
                junk = imgnls (in2, inbuf2, invec2)
                junk = impnls (out, outbuf, ovec)
                call amovs (Mems[inbuf1], Mems[outbuf],     nx1)
                call amovs (Mems[inbuf2], Mems[outbuf+nx1], nx2)
            }

	    # Copy second two quadrants
	    call amovkl (long(1), invec1, IM_MAXDIM)
	    call amovkl (long(1), invec2, IM_MAXDIM)
            while (imgnls (in3, inbuf1, invec1) != EOF) {
                junk = imgnls (in4, inbuf2, invec2)
                junk = impnls (out, outbuf, ovec)
                call amovs (Mems[inbuf1], Mems[outbuf],     nx1)
                call amovs (Mems[inbuf2], Mems[outbuf+nx1], nx2)
            }

        case TY_USHORT, TY_INT, TY_LONG:
	    # Copy first two quadrants
	    call amovkl (long(1), invec1, IM_MAXDIM)
	    call amovkl (long(1), invec2, IM_MAXDIM)
            while (imgnll (in1, inbuf1, invec1) != EOF) {
                junk = imgnll (in2, inbuf2, invec2)
                junk = impnll (out, outbuf, ovec)
                call amovl (Meml[inbuf1], Meml[outbuf],     nx1)
                call amovl (Meml[inbuf2], Meml[outbuf+nx1], nx2)
            }

	    # Copy second two quadrants
	    call amovkl (long(1), invec1, IM_MAXDIM)
	    call amovkl (long(1), invec2, IM_MAXDIM)
            while (imgnll (in3, inbuf1, invec1) != EOF) {
                junk = imgnll (in4, inbuf2, invec2)
                junk = impnll (out, outbuf, ovec)
                call amovl (Meml[inbuf1], Meml[outbuf],     nx1)
                call amovl (Meml[inbuf2], Meml[outbuf+nx1], nx2)
            }

        case TY_REAL:
	    # Copy first two quadrants
	    call amovkl (long(1), invec1, IM_MAXDIM)
	    call amovkl (long(1), invec2, IM_MAXDIM)
            while (imgnlr (in1, inbuf1, invec1) != EOF) {
                junk = imgnlr (in2, inbuf2, invec2)
                junk = impnlr (out, outbuf, ovec)
                call amovr (Memr[inbuf1], Memr[outbuf],     nx1)
                call amovr (Memr[inbuf2], Memr[outbuf+nx1], nx2)
            }

	    # Copy second two quadrants
	    call amovkl (long(1), invec1, IM_MAXDIM)
	    call amovkl (long(1), invec2, IM_MAXDIM)
            while (imgnlr (in3, inbuf1, invec1) != EOF) {
                junk = imgnlr (in4, inbuf2, invec2)
                junk = impnlr (out, outbuf, ovec)
                call amovr (Memr[inbuf1], Memr[outbuf],     nx1)
                call amovr (Memr[inbuf2], Memr[outbuf+nx1], nx2)
            }

        case TY_DOUBLE:
	    # Copy first two quadrants
	    call amovkl (long(1), invec1, IM_MAXDIM)
	    call amovkl (long(1), invec2, IM_MAXDIM)
            while (imgnld (in1, inbuf1, invec1) != EOF) {
                junk = imgnld (in2, inbuf2, invec2)
                junk = impnld (out, outbuf, ovec)
                call amovd (Memd[inbuf1], Memd[outbuf],     nx1)
                call amovd (Memd[inbuf2], Memd[outbuf+nx1], nx2)
            }

	    # Copy second two quadrants
	    call amovkl (long(1), invec1, IM_MAXDIM)
	    call amovkl (long(1), invec2, IM_MAXDIM)
            while (imgnld (in3, inbuf1, invec1) != EOF) {
                junk = imgnld (in4, inbuf2, invec2)
                junk = impnld (out, outbuf, ovec)
                call amovd (Memd[inbuf1], Memd[outbuf],     nx1)
                call amovd (Memd[inbuf2], Memd[outbuf+nx1], nx2)
            }

        case TY_COMPLEX:
	    # Copy first two quadrants
	    call amovkl (long(1), invec1, IM_MAXDIM)
	    call amovkl (long(1), invec2, IM_MAXDIM)
            while (imgnlx (in1, inbuf1, invec1) != EOF) {
                junk = imgnlx (in2, inbuf2, invec2)
                junk = impnlx (out, outbuf, ovec)
                call amovx (Memx[inbuf1], Memx[outbuf],     nx1)
                call amovx (Memx[inbuf2], Memx[outbuf+nx1], nx2)
            }

	    # Copy second two quadrants
	    call amovkl (long(1), invec1, IM_MAXDIM)
	    call amovkl (long(1), invec2, IM_MAXDIM)
            while (imgnlx (in3, inbuf1, invec1) != EOF) {
                junk = imgnlx (in4, inbuf2, invec2)
                junk = impnlx (out, outbuf, ovec)
                call amovx (Memx[inbuf1], Memx[outbuf],     nx1)
                call amovs (Memx[inbuf2], Memx[outbuf+nx1], nx2)
            }

        default:
            call error (1, "unknown pixel datatype")
        }

	call quadmerge (in1, in2, in3, in4, out)

	call imunmap (in1)
	call imunmap (in2)
	call imunmap (in3)
	call imunmap (in4)
	call imunmap (out)
	call hdmclose ()
end
