include <imhdr.h>
include "quad.h"
procedure quadmerge (in1, in2, in3, in4, out)

pointer	in1		#I Pointer to first  quadrant image
pointer	in2		#I Pointer to second quadrant image
pointer	in3		#I Pointer to third  quadrant image
pointer	in4		#I Pointer to fourth quadrant image
pointer	out		#I Pointer to output image

char	ccdsec[SZ_LINE], ampsec[SZ_LINE]
int	cx1, cx2, cxs, cy1, cy2, cys
int	ccx1, ccx2, ccy1, ccy2
real	rval, ccdmean

real	hdmgetr()
int	hdmaccf()

begin
	# Merge ccdsec
	call hdmgstr (in1, "ccdsec", ccdsec, SZ_LINE)
	cx1  = 1
	cy1  = 1
	call ccd_section (ccdsec, cx1, cx2, cxs, cy1, cy2, cys)
	ccx1 = cx1
	ccy1 = cy1

	call hdmgstr (in2, "ccdsec", ccdsec, SZ_LINE)
	cx2  = IM_LEN (out, 1)
	call ccd_section (ccdsec, cx1, cx2, cxs, cy1, cy2, cys)
	ccx2 = cx2

	call hdmgstr (in3, "ccdsec", ccdsec, SZ_LINE)
	cy2  = IM_LEN (out, 2)
	call ccd_section (ccdsec, cx1, cx2, cxs, cy1, cy2, cys)
	ccy2 = cy2

	call sprintf (ccdsec, SZ_LINE, "[%d:%d,%d:%d]")
	    call pargi (ccx1)
	    call pargi (ccx2)
	    call pargi (ccy1)
	    call pargi (ccy2)
	call hdmpstr (out, "ccdsec", ccdsec)

	# Set AMPSECnm 
	call sprintf (ampsec, SZ_LINE, "[%d:%d,%d:%d]")
	    call pargi (1)
	    call pargi (IM_LEN(in1, 1))
	    call pargi (1)
	    call pargi (IM_LEN(in1, 2))
	call hdmpstr (out, "ampsec11", ampsec)

	call sprintf (ampsec, SZ_LINE, "[%d:%d,%d:%d]")
	    call pargi (IM_LEN(in1, 1)+1)
	    call pargi (IM_LEN(out, 1))
	    call pargi (1)
	    call pargi (IM_LEN(in1, 2))
	call hdmpstr (out, "ampsec12", ampsec)

	call sprintf (ampsec, SZ_LINE, "[%d:%d,%d:%d]")
	    call pargi (1)
	    call pargi (IM_LEN(in1, 1))
	    call pargi (IM_LEN(in1, 2)+1)
	    call pargi (IM_LEN(out, 2))
	call hdmpstr (out, "ampsec21", ampsec)

	call sprintf (ampsec, SZ_LINE, "[%d:%d,%d:%d]")
	    call pargi (IM_LEN(in1, 1)+1)
	    call pargi (IM_LEN(out, 1))
	    call pargi (IM_LEN(in1, 2)+1)
	    call pargi (IM_LEN(out, 2))
	call hdmpstr (out, "ampsec22", ampsec)

	# Tidy up processing history
	if (hdmaccf (out, "trim") == YES)
	    call hdmpstr (out, "trim",     "Trimmed")

	if (hdmaccf (out, "overscan") == YES) {
	    call hdmdelf (out, "overscan")
	    call hdmpstr (out, "overscan", "Overscan corrected")
	    call quadoverscan (in1, out, 1)
	    call quadoverscan (in2, out, 2)
	    call quadoverscan (in3, out, 3)
	    call quadoverscan (in4, out, 4)
	}

	if (hdmaccf (out, "ccdmean") == YES) {
	    rval = hdmgetr (in1, "ccdmean")
	    call hdmputr (out, "ccdmea11", rval)
	    ccdmean = rval
	    rval = hdmgetr (in2, "ccdmean")
	    call hdmputr (out, "ccdmea12", rval)
	    ccdmean = ccdmean + rval
	    rval = hdmgetr (in3, "ccdmean")
	    call hdmputr (out, "ccdmea21", rval)
	    ccdmean = ccdmean + rval
	    rval = hdmgetr (in4, "ccdmean")
	    call hdmputr (out, "ccdmea22", rval)
	    ccdmean = ccdmean + rval
	    ccdmean = ccdmean / 4
	    call hdmdelf (out, "ccdmean")
	    call hdmputr (out, "ccdmean", ccdmean)
	}
end

define	MEANTXT		"mean="

procedure quadoverscan (in, out, quadrant)

pointer	in		# Input quadrant image
pointer	out		# Output image
int	quadrant	# Quadrant to label

char	biasval[SZ_LINE], rootname[6], fullname[8]
char	buffer[SZ_LINE]
int	brk

int	strsearch()

begin

	call hdmgstr (in, "overscan", buffer, SZ_LINE)
	brk = strsearch (buffer, MEANTXT)
	if (brk != 0) {
	    call strcpy (buffer[brk], biasval, SZ_LINE)
	    call sprintf (buffer, SZ_LINE, "mean=%s")
		call pargstr (biasval)

	    call hdmname ("overscan", rootname, 6)
	    switch (quadrant) {
	    case 1:
		call sprintf (fullname, 8, "%s%s")
		    call pargstr (rootname)
		    call pargstr (QUAD1)
	    case 2:
		call sprintf (fullname, 8, "%s%s")
		    call pargstr (rootname)
		    call pargstr (QUAD2)
	    case 3:
		call sprintf (fullname, 8, "%s%s")
		    call pargstr (rootname)
		    call pargstr (QUAD3)
	    case 4:
		call sprintf (fullname, 8, "%s%s")
		    call pargstr (rootname)
		    call pargstr (QUAD4)
	    }
	    call hdmpstr (out, fullname, buffer)
	}
end
