procedure quadproc (images)

string	images	       {"", prompt="List of CCD images to correct"}

struct	*fdtmp		{prompt="Internal use only"}

begin
	string	tmplist, tmpim, image, offset, backup, buffer
	int	len

	backup  = ccdred.backup
	tmplist = mktemp ("uparm$tmp")
	files (images, >> tmplist)
	fdtmp = tmplist
	while (fscan (fdtmp, image) != EOF) {

	    len = strlen (image)
	    if (substr(image, len-3, len) == ".imh") {
		image = substr (image, 1, len-4)
	    }

	    # Check to see if we have passed this way before. Assume we
	    # have if the image has been trimmed and skip it.
	    ccdgetparam (image, "trim") | scan (buffer)
	    if (buffer != "UNDEFINED!")
		next

	    # Check to see if image is of type to be processed.
	    if (ccdproc.ccdtype != "") {
		ccdgetparam (image, "imagetyp") | scan (buffer)
		if (buffer != ccdproc.ccdtype)
		    next
	    }

	    # Split out one image for each quadrant and set header sections
	    quadsplit (image, out="")

	    # Overscan correct and trim
	    ccdproc (image//".??.imh", fixpix=no, overscan=yes, trim=yes,
	    zerocor=no, darkcor=no, flatcor=no, illumcor=no, fringecor=no,
	    readcor=no, scancor=no, trimsec="image", biassec="image")

	    # Combine processed quadrants into single image
	    tmpim = mktemp (image)
	    quadjoin (image, tmpim)
	    ccddelete (image)
	    imrename (tmpim, image) 

	    # Delete individual quadrant images including any backup copies
	    # made by ccdproc
	    imdelete (image//".??.imh", ver-)
	    if (backup != "") {
		imdelete (backup//image//".??.imh", ver-)
	    }
	}
	delete (tmplist, ver-)
end
